#include "AI.h"
#include "Joypad.h"

void Jump(SpawnedGameObject *obj)
{
	obj->state = GAMEOBJECT_STATE_JUMPING;
	obj->updateRegisters = true;
	obj->velocity.y = OURHERO_VERTICAL_JUMP_VELOCITY;

	if (joypad1.left)
	{
		obj->facing = GAMEOBJECT_FACING_LEFT;
		obj->velocity.x = -OURHERO_HORIZONTAL_JUMP_VELOCITY;
	}

	if (joypad1.right)
	{
		obj->facing = GAMEOBJECT_FACING_RIGHT;
		obj->velocity.x = OURHERO_HORIZONTAL_JUMP_VELOCITY;
	}
}

void PerformAI(SpawnedGameObject *obj)
{
	bool descending = false;

	if (obj->obj->type == GAMEOBJECT_TYPE_OURHERO)
	{
		//Check to see whether we are colliding with anything that hurts

		//Check to see whether should be falling or not
		if ((obj->state == GAMEOBJECT_STATE_IDLE || obj->state == GAMEOBJECT_STATE_RUNNING) && !IsOnSolidSurface(obj))
		{
			//printf("Our Hero is FALLING!\n");
			obj->state = GAMEOBJECT_STATE_JUMPING;
			obj->velocity.x = 0;
			obj->velocity.y = MAX_FREE_FALL_VELOCITY;
			obj->updateRegisters = true;
			return;
		}

		if (obj->state == GAMEOBJECT_STATE_IDLE)
		{
			//printf("Our Hero is IDLE!\n");

			//Jump
			if (joypad1.b)
			{
				Jump(obj);
				/*
				obj->state = GAMEOBJECT_STATE_JUMPING;
				obj->updateRegisters = true;
				obj->velocity.y = OURHERO_VERTICAL_JUMP_VELOCITY;

				if (joypad1.left)
				{
					obj->facing = GAMEOBJECT_FACING_LEFT;
					obj->velocity.x = -OURHERO_HORIZONTAL_JUMP_VELOCITY;
				}

				if (joypad1.right)
				{
					obj->facing = GAMEOBJECT_FACING_RIGHT;
					obj->velocity.x = OURHERO_HORIZONTAL_JUMP_VELOCITY;
				}
				*/
				return;
			}

			/*
			//Attack
			if (joypad1.a)
			{
				obj->state = GAMEOBJECT_STATE_ATTACKING;
				obj->updateRegisters = true;
				return;
			}
			*/
			//Run
			if (joypad1.left || joypad1.right)
			{
				obj->state = GAMEOBJECT_STATE_RUNNING;
				obj->updateRegisters = true;

				if (joypad1.left)
				{
					obj->facing = GAMEOBJECT_FACING_LEFT;
					obj->velocity.x = -OURHERO_RUNNING_VELOCITY;
				}

				if (joypad1.right)
				{
					obj->facing = GAMEOBJECT_FACING_RIGHT;
					obj->velocity.x = OURHERO_RUNNING_VELOCITY;
				}
				return;
			}

			return;
		}

		if (obj->state == GAMEOBJECT_STATE_RUNNING)
		{
			if (joypad1.b)
			{
				Jump(obj);
				return;
			}

			if (obj->facing == GAMEOBJECT_FACING_LEFT && joypad1.right)
			{
				obj->facing = GAMEOBJECT_FACING_RIGHT;
				obj->velocity.x = -obj->velocity.x;
				obj->updateRegisters = true;
				return;
			}

			if (obj->facing == GAMEOBJECT_FACING_RIGHT && joypad1.left)
			{
				obj->facing = GAMEOBJECT_FACING_LEFT;
				obj->velocity.x = -obj->velocity.x;
				obj->updateRegisters = true;
				return;
			}

			if (!joypad1.left && !joypad1.right)
			{
				obj->state = GAMEOBJECT_STATE_IDLE;
				obj->velocity.x = 0;
				obj->velocity.y = 0;
				obj->updateRegisters = true;
				return;
			}
			return;
		}

		if (obj->state == GAMEOBJECT_STATE_JUMPING)
		{
			if (IsOnSolidSurface(obj))
			{
				//printf("Our Hero is LANDED!\n");

				obj->state = GAMEOBJECT_STATE_IDLE;
				obj->velocity.x = 0;
				obj->velocity.y = 0;

				//We want to react to user input in the same fram that the object has hit the ground.
				if (joypad1.left || joypad1.right || joypad1.a || joypad1.b)
					PerformAI(obj);

				obj->updateRegisters = true;
				return;
			}

			obj->velocity.y += GRAVITY_FACTOR;

			if (obj->velocity.y > MAX_FREE_FALL_VELOCITY)
				obj->velocity.y = MAX_FREE_FALL_VELOCITY;

			return;
		}
	}
}
