#ifndef __BITMAPPARSER_H__
#define __BITMAPPARSER_H__

#define COLOUR_TRANSPARANT                  0x07FE

#include "misc.h"
#include "Sprite.h"

typedef struct BitmapHeader BitmapHeader;
typedef struct GraphicLocation GraphicLocation;

struct BitmapHeader
{
    short signature __attribute__ ((packed));
    long fileSize __attribute__ ((packed));
    long reserved __attribute__ ((packed));
    unsigned long rasterOffset __attribute__ ((packed));
    long infoHeaderSize __attribute__ ((packed));
    unsigned long width __attribute__ ((packed));
    unsigned long height __attribute__ ((packed));
    short planes __attribute__ ((packed));
    short bitCount __attribute__ ((packed));
    long compression __attribute__ ((packed));
    long imageSize __attribute__ ((packed));
    long xPixelPerM __attribute__ ((packed));
    long yPixelPerM __attribute__ ((packed));
    long coloursUsed __attribute__ ((packed));
    long coloursImportant __attribute__ ((packed));
    //long *colorTable;
};

struct GraphicLocation
{
    //short id __attribute__ ((packed));
    short x __attribute__ ((packed));
    short y __attribute__ ((packed));
    short dx __attribute__ ((packed));
    short dy __attribute__ ((packed));
};

void ReorderSegment(byte *segment16x16);
void LoadSpriteGraphics(char *bitmapName, char *dataName);
int LocateColour(unsigned short *pallet, unsigned short colour);
void RemapPalletEntries(SpriteSegment *spriteSegment, short *remap);
int InsertPallet(unsigned short *globalPallet,SpriteSegment *spriteSegment, unsigned short *localPallet);
void ParseSprite(byte *imageData, int imageWidth, int imageHeight, int x, int y, int spriteWidth, int spriteHeight, GameSprite *sprite, unsigned short *sharedSpritePallet);
void ParseTiles(byte *imageData, short imageWidth, short imageHeight, short x, short y, short verticalTiles, short horizontalTiles, unsigned short *sharedPallet);

#endif
