#include "Camera.h"
#include "GameObject.h"
#include "Level.h"

inline short TranslateHorizontal(short x)
{
	return(x - camera.x);
}

inline short TranslateVertical(short y)
{
	return(y - camera.y);
}

//The camera points to the upper left corner of the viewable area.
//It tracks the player according to the tracking mode that it is on.
//The camera will snap to the edges of the level so the areas outside of there never come into view
void UpdateCamera(bool reset)
{
	short x, y;
	SpawnedGameObject *hero = &spawnedGameObjectPool[0];
	camera.dx = 0;
	camera.dy = 0;

	if (hero->state == VACANT_SLOT)
		return;

	if (reset)
	{
		camera.moved = true;
		camera.x = hero->position.x-128;
		camera.y = hero->position.y-128;

		if (camera.x < 0)
			camera.x = 0;
		if (camera.x > (level.width<<4) + 255)
			camera.x = (level.width<<4) + 255;
		if (camera.y < 0)
			camera.y = 0;
		if (camera.y > (level.height<<4) + 255)
			camera.y = (level.height<<4) + 255;

		return;
	}

	if (camera.type == CAMERA_TYPE_HORIZONTAL_TRACE || camera.type == CAMERA_TYPE_ALL_TRACE)
	{

		x = hero->position.x-128;

		if (x != camera.x)
		{
			camera.dx = hero->position.x-128 - camera.x;
			camera.x = x;

			if (camera.x < 0)
				camera.x = 0;
			if (camera.x > (level.width<<4) + 255)
				camera.x = (level.width<<4) + 255;

			camera.moved = true;
		}


		//printf("camera.dx: %i\n", camera.dx);
		//WaitKey();
	}

	if (camera.type == CAMERA_TYPE_VERTICAL_TRACE || camera.type == CAMERA_TYPE_ALL_TRACE)
	{
		y = hero->position.y-128;

		if (y != camera.y)
		{
			camera.dy = hero->position.y - camera.y-128;
			camera.y = y;

			if (camera.y < 0)
				camera.y = 0;

			if (camera.y > (level.height<<4) + 255)
				camera.y = (level.height<<4) + 255;

			camera.moved = true;
		}
		//printf("camera.dy: %i\n", camera.dy);
		//WaitKey();
	}

	//if (camera.moved)
	//	printf("camera.x: %i\n", camera.x);
}
