#ifndef __RENDERER_H__
#define __RENDERER_H__

#include "misc.h"
#include "Level.h"

typedef struct Surface Surface;

struct Surface
{
	bool enabled;
	VectorINT16 *viewport;
	VectorINT16 renderPoint;
	short *renderSurface;
	byte cameraShiftFactor;
	struct TwoDimensionalMap *map;
} levelSurface, backgroundSurface;

void inline RenderTile(byte *tile, int x, int y, short *renderSurface);
void inline RenderSolidColouredTile(short colour, int x, int y, short *renderSurface);
void inline EraseTile(int x, int y, short *renderSurface);
void RenderSurface(Surface *surface, bool reset);

#endif
