#include "Animation.h"
#include "GameObject.h"
#include "Camera.h"

void UpdateObjectAnimation(SpawnedGameObject *gameObj)
{
	bool flip = (gameObj->facing == GAMEOBJECT_FACING_RIGHT) ? false : true;
    Animation *animation = gameObj->obj->animations[gameObj->state];
    if (gameObj->currentFrame >= animation->numberOfFrames)
    {
        if (animation->type == ANIMATION_TYPE_ONCE)
            gameObj->currentFrame = animation->numberOfFrames-1;
        else if (animation->type == ANIMATION_TYPE_LOOP)
            gameObj->currentFrame = 0;
    }
    LoadSpriteIntoVRAMREGST(animation->frame[gameObj->currentFrame], TranslateHorizontal(gameObj->position.x+gameObj->obj->horizontalSpriteOffset), TranslateVertical(gameObj->position.y+gameObj->obj->verticalSpriteOffset), flip, gameObj->spriteRegisters);
}

