//#pragma pack(1)

#include "misc.h"
#include "camera.h"
#include "level.h"
#include "animation.h"
#include "Joypad.h"
#include "AI.h"
#include "Renderer.h"
#include "GameLoop.h"

void InitGame()
{
    int i, j, id, animation, frame, animations, frames;

    //This allows us to access memory freely.
	_iocs_b_super(0);

    //Change graphics mode, clear graphics memory and turn on sprites

    _iocs_crtmod(11);
	//_iocs_crtmod(8); // 512x512@256
	_iocs_g_clr_on();
	_iocs_sp_init();
	_iocs_sp_on();

	levelSurface.enabled = true;
	levelSurface.cameraShiftFactor = 0;
	levelSurface.renderSurface = GVRAM0;
	levelSurface.viewport = GVRAM0_POSITION;
	levelSurface.map = &level;

	backgroundSurface.enabled = true;
	backgroundSurface.cameraShiftFactor = 1;
	backgroundSurface.renderSurface = GVRAM1;
	backgroundSurface.viewport = GVRAM1_POSITION;
	backgroundSurface.map = &background;

	//printf("1!\n");
	//WaitKey();

    LoadSpriteGraphics("sprite.bmp", "sprite.bin");
    //printf("2!\n");
    //WaitKey();
    LoadLevel(1);
    //printf("3!\n");
    //WaitKey();
}

void MakeDat()
{
	int h, v;
    int fd = MakeFile("sprite.bin");

	//Load Animations
	{
		//Number of animations
		PushINT16(fd, 3);

		{
			//Number of frames in current animation (Standing)
			PushINT16(fd, 1);

			//First frame location in bitmap
			PushINT16(fd, 0);
			PushINT16(fd, 0);
			PushINT16(fd, 24);
			PushINT16(fd, 37);
		}

		{
			//Number of frames in current animation (Jumping)
			PushINT16(fd, 1);

			//First frame location in bitmap
			PushINT16(fd, 130);
			PushINT16(fd, 0);
			PushINT16(fd, 36);
			PushINT16(fd, 37);
		}

		{
			//Number of frames in current animation (Running)
			PushINT16(fd, 4);

			//First frame location in bitmap
			PushINT16(fd, 25);
			PushINT16(fd, 0);
			PushINT16(fd, 24);
			PushINT16(fd, 37);

			//Second frame location in bitmap
			PushINT16(fd, 50);
			PushINT16(fd, 0);
			PushINT16(fd, 26);
			PushINT16(fd, 37);

			//Third frame location in bitmap
			PushINT16(fd, 77);
			PushINT16(fd, 0);
			PushINT16(fd, 23);
			PushINT16(fd, 37);

			//Fourth frame location in bitmap
			PushINT16(fd, 101);
			PushINT16(fd, 0);
			PushINT16(fd, 28);
			PushINT16(fd, 37);
		}
	}

    //Number of game objects
    PushINT16(fd, 1);

    //first object type
    PushINT16(fd, 0);
    //first object width
    PushINT16(fd, 18);
    //first object height
    PushINT16(fd, 37);
    //first object horizontal sprite offset
    PushINT16(fd, -6);
    //first object vertical sprite offset
    PushINT16(fd, 0);
    //first object number of animations
    PushINT16(fd, 3);
    //first object first animation pose
    PushINT16(fd, 0);
    //first object first pose animation id
    PushINT16(fd, 0);
    //first object second pose
    PushINT16(fd, 1);
    //first object second animation id
    PushINT16(fd, 1);
    //first object third pose
    PushINT16(fd, 2);
    //first object third animation id
    PushINT16(fd, 2);

	//Graphic tiles
	{
		//location of tiles in bitmap
		PushINT16(fd, 208);
		PushINT16(fd, 0);
		//Number of horizontal tiles
		PushINT16(fd, 3);
		//Number of vertical tiles
		PushINT16(fd, 2);
	}

    _dos_close(fd);
	/*
    fd = MakeFile("Object01.dat");
    //Offset of level objects
    PushINT16(fd, 4);
    //Offset of level geometry
    PushINT16(fd, 12);
    //Number of level objects
    PushINT16(fd, 1);
    //first level object type
    PushINT16(fd, 0);
    //first level object x coordinate
    PushINT16(fd, 128-40);
    //first level object y coordinate
    PushINT16(fd, 40);

    //number of level geometry
    PushINT16(fd, (11*2)+level.width*2+(level.width/2));

    {
    	v = 0;
    	for (h = 0; h < level.width; h++)
		{
			//16x16 block type
			PushINT16(fd, 1);
			//Horizontal slot
			PushINT16(fd, h);
			//Vertical slot
			PushINT16(fd, v);
		}

    	v = 9;
    	for (h = 0; h < level.width; h++)
		{
			if (h % 8 < 4)
				continue;
			//16x16 block type
			PushINT16(fd, 3);
			//Horizontal slot
			PushINT16(fd, h);
			//Vertical slot
			PushINT16(fd, v);
		}

    	v = 11;
    	for (h = 0; h < level.width; h++)
		{
			//16x16 block type
			PushINT16(fd, 2);
			//Horizontal slot
			PushINT16(fd, h);
			//Vertical slot
			PushINT16(fd, v);
		}


		h = 0;
    	for (v = 0; v < 11; v++)
		{
			//16x16 block type
			PushINT16(fd, 5);
			//Horizontal slot
			PushINT16(fd, h);
			//Vertical slot
			PushINT16(fd, v);
		}

		h = level.width-1;
    	for (v = 0; v < 11; v++)
		{
			//16x16 block type
			PushINT16(fd, 5);
			//Horizontal slot
			PushINT16(fd, h);
			//Vertical slot
			PushINT16(fd, v);
		}
   }
    //Level camera start x
    //PushINT16(fd, 0);
    //Level camera start y
    //PushINT16(fd, 0);

    _dos_close(fd);
    */
}
/*
void MakeDat()
{
	int h, v;
    int fd = MakeFile("sprite.dat");

	//Load Animations
	{
		//Number of animations
		PushINT16(fd, 3);

		{
			//Number of frames in current animation (Standing)
			PushINT16(fd, 1);

			//First frame location in bitmap
			PushINT16(fd, 0);
			PushINT16(fd, 0);
			PushINT16(fd, 24);
			PushINT16(fd, 40);
		}

		{
			//Number of frames in current animation (Jumping)
			PushINT16(fd, 1);

			//First frame location in bitmap
			PushINT16(fd, 130);
			PushINT16(fd, 0);
			PushINT16(fd, 36);
			PushINT16(fd, 40);
		}

		{
			//Number of frames in current animation (Running)
			PushINT16(fd, 4);

			//First frame location in bitmap
			PushINT16(fd, 25);
			PushINT16(fd, 0);
			PushINT16(fd, 24);
			PushINT16(fd, 40);

			//Second frame location in bitmap
			PushINT16(fd, 50);
			PushINT16(fd, 0);
			PushINT16(fd, 26);
			PushINT16(fd, 40);

			//Third frame location in bitmap
			PushINT16(fd, 77);
			PushINT16(fd, 0);
			PushINT16(fd, 23);
			PushINT16(fd, 40);

			//Fourth frame location in bitmap
			PushINT16(fd, 101);
			PushINT16(fd, 0);
			PushINT16(fd, 28);
			PushINT16(fd, 40);
		}
	}

    //Number of game objects
    PushINT16(fd, 1);

    //first object type
    PushINT16(fd, 0);
    //first object width
    PushINT16(fd, 24);
    //first object height
    PushINT16(fd, 40);
    //first object number of animations
    PushINT16(fd, 3);
    //first object first animation pose
    PushINT16(fd, 0);
    //first object first pose animation id
    PushINT16(fd, 0);
    //first object second pose
    PushINT16(fd, 1);
    //first object second animation id
    PushINT16(fd, 1);
    //first object third pose
    PushINT16(fd, 2);
    //first object third animation id
    PushINT16(fd, 2);

	//Load graphic tiles
	{
		//location of tiles in bitmap
		PushINT16(fd, 208);
		PushINT16(fd, 0);
		PushINT16(fd, 3);
		PushINT16(fd, 2);
	}

    _dos_close(fd);

    fd = MakeFile("Level01.dat");
    //Offset of level objects
    PushINT16(fd, 4);
    //Offset of level geometry
    PushINT16(fd, 12);
    //Number of level objects
    PushINT16(fd, 1);
    //first level object type
    PushINT16(fd, 0);
    //first level object x coordinate
    PushINT16(fd, 128-40);
    //first level object y coordinate
    PushINT16(fd, 40);

    //number of level geometry
    PushINT16(fd, (11*2)+level.width*2+(level.width/2));

    {
    	v = 0;
    	for (h = 0; h < level.width; h++)
		{
			//16x16 block type
			PushINT16(fd, 1);
			//Horizontal slot
			PushINT16(fd, h);
			//Vertical slot
			PushINT16(fd, v);
		}

    	v = 9;
    	for (h = 0; h < level.width; h++)
		{
			if (h % 8 < 4)
				continue;
			//16x16 block type
			PushINT16(fd, 3);
			//Horizontal slot
			PushINT16(fd, h);
			//Vertical slot
			PushINT16(fd, v);
		}

    	v = 11;
    	for (h = 0; h < level.width; h++)
		{
			//16x16 block type
			PushINT16(fd, 2);
			//Horizontal slot
			PushINT16(fd, h);
			//Vertical slot
			PushINT16(fd, v);
		}


		h = 0;
    	for (v = 0; v < 11; v++)
		{
			//16x16 block type
			PushINT16(fd, 5);
			//Horizontal slot
			PushINT16(fd, h);
			//Vertical slot
			PushINT16(fd, v);
		}

		h = level.width-1;
    	for (v = 0; v < 11; v++)
		{
			//16x16 block type
			PushINT16(fd, 5);
			//Horizontal slot
			PushINT16(fd, h);
			//Vertical slot
			PushINT16(fd, v);
		}
   }

    //Level camera start x
    //PushINT16(fd, 0);
    //Level camera start y
    //PushINT16(fd, 0);

    _dos_close(fd);
}*/

int main(void)
{
	int timestamp;
	int timer;
	int frames = 0;
	float fps;

	heap = (void *)0xBFFFF;

    MakeDat();
    InitGame();

    //printf("Game Init!\n");
    //WaitKey();


    //*((byte *)0xE8A01B) |= 0x01;
    //*((byte *)0xE8A001) = 0x00;
    //*((byte *)0xE8A01B) &= 0xFE;
	timestamp = *((char *)0xE8A001);

	do
	{
		/*
		timer += (*((char *)0xE8A001)-timestamp) != 0 ? 1 : 0;
		timestamp = *((char *)0xE8A001);
		if (frames % 480 == 0 && frames > 0)
		{
			fps = 480.0f/(float)timer;
			printf("fps: %f\n", fps);
			timer = 0;
		}
		*/
		PollJoypad(0, &joypad1);
		//printf("Game 1!\n");
		//WaitKey();
        GameLoop();
		//printf("Game 2!\n");
		//WaitKey();
		frames++;
	}
	while(_dos_k_keyinp() != 13);

	CleanUp();

    return(0);
}
